- Aldebaran documentation |
- C++ Libraries |
- index

libalvision 2.8.7.4

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Namespace List
- Namespace Members

All Classes Namespaces Files Functions Variables Friends Macros Pages
Classes | Functions | Variables
AL Namespace Reference

## Classes
class | ALExtractor
class | ALImage
struct | streamHeader
struct | videoHeader
struct | streamProperties
class | ALVideo
class | ALVisionExtractor
| ALVisionExtractor is a generic vision extractor. More...

## Functions
bool | isResolutionValid (const int resIndex)
| Utility function that checks that a resolution index is valid. (ie, present in the definitions just above) More...
void | setSizeFromResolution (const int resIndex, int &outWidth, int &outHeight)
| Utility function that takes a resolution index as an input and returns the corresponding width and height values. If resolution index is unknown, width and height are set to -1. More...
int | getResolutionFromSize (const int width, const int height)
| Utility function that takes width and height as inputs and returns the corresponding resolution index. More...
bool | isColorSpaceValid (const int colorspace)
| Utility function that checks that a color space index is valid. (ie, present in the definitions just above) More...
int | getNumLayersInColorSpace (const int colorSpace)
| Utility function that returns the number of layers for a given color space. More...
int | getNumChannelsInColorSpace (const int colorSpace)
| Utility function that returns the number of channels for a given color space. More...
float | convertAngleValToNormalizedImgVal (const float &radValue, const float &imageRadMin, const float &imageRadMax)
float | convertAnglePosToNormalizedImgPos (const float &radPosition, const float &imageRadMin, const float &imageRadMax)

## Variables
const int | kOV7670 = 1
const int | kMT9M114 = 2
const int | kOV5640 = 3
const int | kXTION = 4
const int | kSimulator2D = 5
const int | kSimulator3D = 6
const int | kStereo = 7
const int | kOV4689 = 8
const int | kTopCamera = 0
const int | kBottomCamera = 1
const int | kDepthCamera = 2
const int | kStereoCamera = 3
const float | kApertureH_OV7670 = 47.8f
const float | kApertureV_OV7670 = 36.8f
const float | kApertureH_MT9M114 = 60.9f
const float | kApertureV_MT9M114 = 47.6f
const int | k16VGA = 4
const int | k4VGA = 3
const int | kVGA = 2
const int | kQVGA = 1
const int | kQQVGA = 0
const int | kQQQVGA = 7
const int | kQQQQVGA = 8
const int | k1080p = 6
const int | k720p = 5
const int | kQ720p = 9
const int | kQQ720p = 10
const int | kQQQ720p = 11
const int | kQQQQ720p = 12
const int | k720px2 = 13
const int | kQ720px2 = 14
const int | kQQ720px2 = 15
const int | kQQQ720px2 = 16
const int | kQQQQ720px2 = 17
const int | k960p = k4VGA
const int | k1920p = k16VGA
const int | kYuvColorSpace = 0
const int | kyUvColorSpace = 1
const int | kyuVColorSpace = 2
const int | kRgbColorSpace = 3
const int | krGbColorSpace = 4
const int | krgBColorSpace = 5
const int | kHsyColorSpace = 6
const int | khSyColorSpace = 7
const int | khsYColorSpace = 8
const int | kYUV422ColorSpace = 9
const int | kYUV422InterlacedColorSpace = kYUV422ColorSpace
const int | kYUVColorSpace = 10
const int | kRGBColorSpace = 11
const int | kHSYColorSpace = 12
const int | kBGRColorSpace = 13
const int | kYYCbCrColorSpace = 14
const int | kH2RGBColorSpace = 15
const int | kHSMixedColorSpace = 16
const int | kDepthColorSpace = 17
const int | kARGBColorSpace = 18
const int | kXYZColorSpace = 19
const int | kInfraredColorSpace = 20
const int | kDistanceColorSpace = 21
const int | kLabColorSpace = 22
const int | kRawDepthColorSpace = 23
const int | kLuvColorSpace = 24
const int | kLChabColorSpace = 25
const int | kLChuvColorSpace = 26
const int | kCameraBrightnessID = 0
const int | kCameraContrastID = 1
const int | kCameraSaturationID = 2
const int | kCameraHueID = 3
const int | kCameraRedChromaID = 4
const int | kCameraBlueChromaID = 5
const int | kCameraGainID = 6
const int | kCameraHFlipID = 7
const int | kCameraVFlipID = 8
const int | kCameraLensXID = 9
const int | kCameraLensYID = 10
const int | kCameraAutoExpositionID = 11
const int | kCameraAutoWhiteBalanceID = 12
const int | kCameraAutoGainID = 13
const int | kCameraResolutionID = 14
const int | kCameraFrameRateID = 15
const int | kCameraBufferSizeID = 16
const int | kCameraExposureID = 17
const int | kCameraSelectID = 18
const int | kCameraSetDefaultParamsID = 19
const int | kCameraColorSpaceID = 20
const int | kCameraExposureCorrectionID = 21
const int | kCameraExposureAlgorithmID = 22
const int | kCameraAecAlgorithmID = kCameraExposureAlgorithmID
const int | kCameraFastSwitchID = 23
const int | kCameraSharpnessID = 24
const int | kCameraAwbGreenGainID = 25
const int | kCameraAblcID = 26
const int | kCameraAblcTargetID = 27
const int | kCameraAblcStableRangeID = 28
const int | kCameraBlcBlueID = 29
const int | kCameraBlcRedID = 30
const int | kCameraBlcGbID = 31
const int | kCameraBlcGrID = 32
const int | kCameraWhiteBalanceID = 33
const int | kCameraBacklightCompensationID = 34
const int | kCameraKeepAliveID = 35
const int | kCameraDepthConfidenceThresholdID = 36
const int | kCameraDepthFastFilterID = 37
const int | kCameraTemperatureID = 38
const int | kCameraAverageLuminanceID = 39
const int | kCameraAutoFocusID = 40
const int | kCameraSynchronisationID = 41
const int | kCameraDisparityWindowSizeID = 42
const int | kCameraFocusID = 43
const int | kCameraTestPatternID = 44

## Detailed Description

Author
  Vincent Rabaud, Guillaume Jacob Aldebaran Robotics (c) 2013, 2014 All Rights Reserved Set of functions to
  - convert between ALImage and cv::Mat
  - load/write ALImage with OpenCV.

This is a header only implementation to be totally independent from OpenCV If you include this header, make sure you link properly to OPENCV3_CORE and OPENCV3_IMGCODECS.

Author
  Aldebaran Robotics Copyright (c) Aldebaran Robotics 2011, 2012 All Rights Reserved

## Function Documentation

float AL::convertAnglePosToNormalizedImgPos | ( | const float & | radPosition,
|  | const float & | imageRadMin,
|  | const float & | imageRadMax
| ) |  |
| inline

Definition at line 196 of file alvisiondefinitions.h.

float AL::convertAngleValToNormalizedImgVal | ( | const float & | radValue,
|  | const float & | imageRadMin,
|  | const float & | imageRadMax
| ) |  |
| inline

Definition at line 191 of file alvisiondefinitions.h.

int AL::getNumChannelsInColorSpace | ( | const int | colorSpace | ) |

Utility function that returns the number of channels for a given color space.

Returns
  The number of channels for this color space.

Note
  This method assumes that the data is stored with the correct type, for example it will return 1 for the AL::kDepthColorSpace because it corresponds to a 1-channel unsigned short image buffer, although it uses two layers.

int AL::getNumLayersInColorSpace | ( | const int | colorSpace | ) |

Utility function that returns the number of layers for a given color space.

Returns
  the number of byte the colorspace use, otherwise returns -1 for unknown colorspace.

Note
  Since this method is use by AL::ALImage to allocate memory with the assumption of 1 layer is stored in 1 byte. Thus if the color space store some channel in a 16bits container (e.g. Depth map), method will return 2 instead of 1.

int AL::getResolutionFromSize | ( | const int | width,
|  | const int | height
| ) |  |

Utility function that takes width and height as inputs and returns the corresponding resolution index.

Returns
  The resolution index otherwise return -1.

bool AL::isColorSpaceValid | ( | const int | colorspace | ) |

Utility function that checks that a color space index is valid. (ie, present in the definitions just above)

bool AL::isResolutionValid | ( | const int | resIndex | ) |

Utility function that checks that a resolution index is valid. (ie, present in the definitions just above)

void AL::setSizeFromResolution | ( | const int | resIndex,
|  | int & | outWidth,
|  | int & | outHeight
| ) |  |

Utility function that takes a resolution index as an input and returns the corresponding width and height values. If resolution index is unknown, width and height are set to -1.

## Variable Documentation

const int AL::k1080p = 6

Definition at line 58 of file alvisiondefinitions.h.

const int AL::k16VGA = 4

Format of the image

Definition at line 50 of file alvisiondefinitions.h.

const int AL::k1920p = k16VGA

Definition at line 72 of file alvisiondefinitions.h.

const int AL::k4VGA = 3

Definition at line 51 of file alvisiondefinitions.h.

const int AL::k720p = 5

Definition at line 59 of file alvisiondefinitions.h.

const int AL::k720px2 = 13

Definition at line 65 of file alvisiondefinitions.h.

const int AL::k960p = k4VGA

Definition at line 71 of file alvisiondefinitions.h.

const float AL::kApertureH_MT9M114 = 60.9f

Deprecated:
  since 1.16

Definition at line 44 of file alvisiondefinitions.h.

const float AL::kApertureH_OV7670 = 47.8f

Cameras aperture

Deprecated:
  Should not be exposed.

Deprecated:
  since 1.16

Definition at line 42 of file alvisiondefinitions.h.

const float AL::kApertureV_MT9M114 = 47.6f

Deprecated:
  since 1.16

Definition at line 45 of file alvisiondefinitions.h.

const float AL::kApertureV_OV7670 = 36.8f

Deprecated:
  since 1.16

Definition at line 43 of file alvisiondefinitions.h.

const int AL::kARGBColorSpace = 18

Definition at line 96 of file alvisiondefinitions.h.

const int AL::kBGRColorSpace = 13

Definition at line 91 of file alvisiondefinitions.h.

const int AL::kBottomCamera = 1

Definition at line 34 of file alvisiondefinitions.h.

const int AL::kCameraAblcID = 26

Definition at line 136 of file alvisiondefinitions.h.

const int AL::kCameraAblcStableRangeID = 28

Definition at line 138 of file alvisiondefinitions.h.

const int AL::kCameraAblcTargetID = 27

Definition at line 137 of file alvisiondefinitions.h.

const int AL::kCameraAecAlgorithmID = kCameraExposureAlgorithmID

Definition at line 132 of file alvisiondefinitions.h.

const int AL::kCameraAutoExpositionID = 11

Definition at line 120 of file alvisiondefinitions.h.

const int AL::kCameraAutoFocusID = 40

Since
  1.22.4

Definition at line 150 of file alvisiondefinitions.h.

const int AL::kCameraAutoGainID = 13

Definition at line 122 of file alvisiondefinitions.h.

const int AL::kCameraAutoWhiteBalanceID = 12

Definition at line 121 of file alvisiondefinitions.h.

const int AL::kCameraAverageLuminanceID = 39

Since
  1.22.2

Definition at line 149 of file alvisiondefinitions.h.

const int AL::kCameraAwbGreenGainID = 25

Definition at line 135 of file alvisiondefinitions.h.

const int AL::kCameraBacklightCompensationID = 34

Definition at line 144 of file alvisiondefinitions.h.

const int AL::kCameraBlcBlueID = 29

Definition at line 139 of file alvisiondefinitions.h.

const int AL::kCameraBlcGbID = 31

Definition at line 141 of file alvisiondefinitions.h.

const int AL::kCameraBlcGrID = 32

Definition at line 142 of file alvisiondefinitions.h.

const int AL::kCameraBlcRedID = 30

Definition at line 140 of file alvisiondefinitions.h.

const int AL::kCameraBlueChromaID = 5

Definition at line 114 of file alvisiondefinitions.h.

const int AL::kCameraBrightnessID = 0

Standard Id (used for camera registers configuration)

Definition at line 109 of file alvisiondefinitions.h.

const int AL::kCameraBufferSizeID = 16

Definition at line 125 of file alvisiondefinitions.h.

const int AL::kCameraColorSpaceID = 20

Definition at line 129 of file alvisiondefinitions.h.

const int AL::kCameraContrastID = 1

Definition at line 110 of file alvisiondefinitions.h.

const int AL::kCameraDepthConfidenceThresholdID = 36

Since
  1.16

Definition at line 146 of file alvisiondefinitions.h.

const int AL::kCameraDepthFastFilterID = 37

Since
  1.16

Definition at line 147 of file alvisiondefinitions.h.

const int AL::kCameraDisparityWindowSizeID = 42

Since
  2.3

Definition at line 152 of file alvisiondefinitions.h.

const int AL::kCameraExposureAlgorithmID = 22

Definition at line 131 of file alvisiondefinitions.h.

const int AL::kCameraExposureCorrectionID = 21

Definition at line 130 of file alvisiondefinitions.h.

const int AL::kCameraExposureID = 17

Definition at line 126 of file alvisiondefinitions.h.

const int AL::kCameraFastSwitchID = 23

Definition at line 133 of file alvisiondefinitions.h.

const int AL::kCameraFocusID = 43

Since
  2.5

Definition at line 153 of file alvisiondefinitions.h.

const int AL::kCameraFrameRateID = 15

Definition at line 124 of file alvisiondefinitions.h.

const int AL::kCameraGainID = 6

Definition at line 115 of file alvisiondefinitions.h.

const int AL::kCameraHFlipID = 7

Definition at line 116 of file alvisiondefinitions.h.

const int AL::kCameraHueID = 3

Definition at line 112 of file alvisiondefinitions.h.

const int AL::kCameraKeepAliveID = 35

Since
  1.16

Definition at line 145 of file alvisiondefinitions.h.

const int AL::kCameraLensXID = 9

Definition at line 118 of file alvisiondefinitions.h.

const int AL::kCameraLensYID = 10

Definition at line 119 of file alvisiondefinitions.h.

const int AL::kCameraRedChromaID = 4

Definition at line 113 of file alvisiondefinitions.h.

const int AL::kCameraResolutionID = 14

Definition at line 123 of file alvisiondefinitions.h.

const int AL::kCameraSaturationID = 2

Definition at line 111 of file alvisiondefinitions.h.

const int AL::kCameraSelectID = 18

Definition at line 127 of file alvisiondefinitions.h.

const int AL::kCameraSetDefaultParamsID = 19

Definition at line 128 of file alvisiondefinitions.h.

const int AL::kCameraSharpnessID = 24

Definition at line 134 of file alvisiondefinitions.h.

const int AL::kCameraSynchronisationID = 41

Since
  2.3

Definition at line 151 of file alvisiondefinitions.h.

const int AL::kCameraTemperatureID = 38

Since
  1.18

Definition at line 148 of file alvisiondefinitions.h.

const int AL::kCameraTestPatternID = 44

Since
  2.7

Definition at line 154 of file alvisiondefinitions.h.

const int AL::kCameraVFlipID = 8

Definition at line 117 of file alvisiondefinitions.h.

const int AL::kCameraWhiteBalanceID = 33

Definition at line 143 of file alvisiondefinitions.h.

const int AL::kDepthCamera = 2

Definition at line 35 of file alvisiondefinitions.h.

const int AL::kDepthColorSpace = 17

Definition at line 95 of file alvisiondefinitions.h.

const int AL::kDistanceColorSpace = 21

Since
  1.22

Definition at line 99 of file alvisiondefinitions.h.

const int AL::kH2RGBColorSpace = 15

Definition at line 93 of file alvisiondefinitions.h.

const int AL::kHSMixedColorSpace = 16

Definition at line 94 of file alvisiondefinitions.h.

const int AL::kHsyColorSpace = 6

Definition at line 83 of file alvisiondefinitions.h.

const int AL::khSyColorSpace = 7

Definition at line 84 of file alvisiondefinitions.h.

const int AL::khsYColorSpace = 8

Definition at line 85 of file alvisiondefinitions.h.

const int AL::kHSYColorSpace = 12

Definition at line 90 of file alvisiondefinitions.h.

const int AL::kInfraredColorSpace = 20

Definition at line 98 of file alvisiondefinitions.h.

const int AL::kLabColorSpace = 22

Definition at line 100 of file alvisiondefinitions.h.

const int AL::kLChabColorSpace = 25

Definition at line 103 of file alvisiondefinitions.h.

const int AL::kLChuvColorSpace = 26

Definition at line 104 of file alvisiondefinitions.h.

const int AL::kLuvColorSpace = 24

Definition at line 102 of file alvisiondefinitions.h.

const int AL::kMT9M114 = 2

Definition at line 22 of file alvisiondefinitions.h.

const int AL::kOV4689 = 8

Definition at line 28 of file alvisiondefinitions.h.

const int AL::kOV5640 = 3

Definition at line 23 of file alvisiondefinitions.h.

const int AL::kOV7670 = 1

Camera Model ID

Definition at line 21 of file alvisiondefinitions.h.

const int AL::kQ720p = 9

Definition at line 60 of file alvisiondefinitions.h.

const int AL::kQ720px2 = 14

Definition at line 66 of file alvisiondefinitions.h.

const int AL::kQQ720p = 10

Definition at line 61 of file alvisiondefinitions.h.

const int AL::kQQ720px2 = 15

Definition at line 67 of file alvisiondefinitions.h.

const int AL::kQQQ720p = 11

Definition at line 62 of file alvisiondefinitions.h.

const int AL::kQQQ720px2 = 16

Definition at line 68 of file alvisiondefinitions.h.

const int AL::kQQQQ720p = 12

Definition at line 63 of file alvisiondefinitions.h.

const int AL::kQQQQ720px2 = 17

Definition at line 69 of file alvisiondefinitions.h.

const int AL::kQQQQVGA = 8

Definition at line 56 of file alvisiondefinitions.h.

const int AL::kQQQVGA = 7

Definition at line 55 of file alvisiondefinitions.h.

const int AL::kQQVGA = 0

Definition at line 54 of file alvisiondefinitions.h.

const int AL::kQVGA = 1

Definition at line 53 of file alvisiondefinitions.h.

const int AL::kRawDepthColorSpace = 23

Since
  2.2

Definition at line 101 of file alvisiondefinitions.h.

const int AL::kRgbColorSpace = 3

Definition at line 80 of file alvisiondefinitions.h.

const int AL::krGbColorSpace = 4

Definition at line 81 of file alvisiondefinitions.h.

const int AL::krgBColorSpace = 5

Definition at line 82 of file alvisiondefinitions.h.

const int AL::kRGBColorSpace = 11

Definition at line 89 of file alvisiondefinitions.h.

const int AL::kSimulator2D = 5

Definition at line 25 of file alvisiondefinitions.h.

const int AL::kSimulator3D = 6

Definition at line 26 of file alvisiondefinitions.h.

const int AL::kStereo = 7

Definition at line 27 of file alvisiondefinitions.h.

const int AL::kStereoCamera = 3

Definition at line 36 of file alvisiondefinitions.h.

const int AL::kTopCamera = 0

Camera Index

Definition at line 33 of file alvisiondefinitions.h.

const int AL::kVGA = 2

Definition at line 52 of file alvisiondefinitions.h.

const int AL::kXTION = 4

Definition at line 24 of file alvisiondefinitions.h.

const int AL::kXYZColorSpace = 19

Definition at line 97 of file alvisiondefinitions.h.

const int AL::kYUV422ColorSpace = 9

Definition at line 86 of file alvisiondefinitions.h.

const int AL::kYUV422InterlacedColorSpace = kYUV422ColorSpace

Definition at line 87 of file alvisiondefinitions.h.

const int AL::kYuvColorSpace = 0

ColorSpace

Definition at line 77 of file alvisiondefinitions.h.

const int AL::kyUvColorSpace = 1

Definition at line 78 of file alvisiondefinitions.h.

const int AL::kyuVColorSpace = 2

Definition at line 79 of file alvisiondefinitions.h.

const int AL::kYUVColorSpace = 10

Definition at line 88 of file alvisiondefinitions.h.

const int AL::kYYCbCrColorSpace = 14

Definition at line 92 of file alvisiondefinitions.h.